//ImagesModifEchelle_502f.js
// 24.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Modifier l'chelle des images.

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// mmoriser le document au premier plan
var curDoc = app.documents[0];

// appeler la fonction qui lit les prfrences mmorises
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var pcVal   = prefVal[0]*1;
	var ck0     = false;
	var ctPic   = prefVal[1];
	if (ctPic  == "true") {
		ck0 = true;
	}
	var grpd    = prefVal[2];
	var ck1     = 1;
	var ck2     = 0;
	if (grpd == "1") {
		ck1 = 0;
		ck2 = 1;
	}
}
else {
	// utiliser les valeurs par dfaut 
	// quand le fichier des prfrences n'existe pas
	var pcVal = 100;
	var ck0   = false;
	var ck1   = 1;
	var ck2   = 0;
}

// demander la valeur du nouveau pourcentage, etc.
var anArray = displayDialog(pcVal, ck0, ck1, ck2);
var pcVal   = anArray[0];
var ck0     = anArray[1];
var grpd    = anArray[2];

// mmoriser une slection ventuelle
var curSel  = app.selection;
var nSel    = curSel.length;
var nPicts  = 0;

// quand il n'y a pas de slection...
if (nSel == 0) {
	var allPicts = curDoc.links;
	var nPicts   = allPicts.length;
}
// ... sinon lister les liens de la slection
else {
	var allPicts = getLinks(nSel, curSel);
	var nPicts   = allPicts.length;
}

// une boucle  travers les liens
for (var i=0; i<nPicts; i++) {
	var isLocked = false;
	try {
		var curPict  = allPicts[i].parent;
		var curFrame = curPict.parent;
		if (grpd == 0) {
			if (curFrame.locked == true) {
				isLocked = true;
				curFrame.locked = false;
			}
		}
		curPict.properties = {horizontalScale:pcVal, verticalScale:pcVal};
		if (ck0) {
			curPict.parent.fit(FitOptions.centerContent);
		}
		if (isLocked) {
			curFrame.locked = true;
		}
	}
	catch (e) {
	}
}

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(1000);
// fermer la fentre
dlog.close();


///////////// LES FONCTIONS ///////////////////////////////////////

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Echelle502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Echelle502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue
function displayDialog(pcVal, ck0, ck1, ck2) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 110;
	var fieldWidth =  40;
	var aDialog = app.dialogs.add({name:"Mettre des images  l'chelle"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Mise  l'chelle ", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var valField = realEditboxes.add({editValue:pcVal, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"%", minWidth:12});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"", minWidth:4});
			var centerCheckbox = checkboxControls.add({staticLabel:"Centrer les images", checkedState:ck0});
			staticTexts.add({staticLabel:"", minWidth:4});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Les images verrouills"});
					staticTexts.add({staticLabel:" ", minWidth:10});
				}
				with(grButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"modifier", checkedState:ck1});
					radiobuttonControls.add({staticLabel:"ignorer", checkedState:ck2});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		var pcVal = valField.editValue;
		var ck0   = centerCheckbox.checkedState;
		var grDec = grButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (pcVal, ck0, grDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [pcVal, ck0, grDec];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Echelle502.txt");
	}
	else {
		var f = File("~/Library/Preferences/Echelle502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// cette fonction collectionne les liens de la slection
function getLinks(nSel, curSel) {
	var linkList = new Array ();
	// une boucle  travers la slection
	for (var p=0; p<nSel; p++) {
		if (curSel[p].hasOwnProperty("graphics") == true) {
			if ((curSel[p].contentType)*1 == 1735553140) { // = "GRAPHIC_TYPE"
				try {
					curLink = curSel[p].graphics[0].itemLink;
					linkList.push(curLink);
				}
				catch (e) {
				}
			}
		}
		else {
			var cName = curSel[p].constructor.name;
			if (cName == "Image" || cName == "PDF" || cName == "EPS") {
				try {
					curLink = curSel[p].itemLink;
					linkList.push(curLink);
				}
				catch (e) {
				}
			}
			if (cName == "Group") {
				var allObj = curSel[p].allPageItems;
				var nObj = allObj.length;
				for (m=0; m<nObj; m++) {
					try {
						curLink = allObj[m].graphics[0].itemLink;
						linkList.push(curLink);
					}
					catch (e) {
					}
				}
			}
		}
	}
	return linkList;
}